// Tables

// Base Style
//
// Basic Bootstrap table
//

.table {
  width: 100%;
  margin-bottom: $spacer;
  color: $table-color;
  background-color: $table-bg; // Reset for nesting within parents with `background-color`.
  @include font-size($table-font-size);

  td {
    padding: $table-cell-padding-y $table-cell-padding-x;
    vertical-align: top;
    border-top: $table-border-width solid $table-border-color;
    font-weight: $font-weight-medium;
    @include set-animation('faded');

    &.table-action {
      min-width: 100px;
      width: 100px;
      padding: 0 !important; // cancel default padding
      text-align: center;

      .btn {
        padding: $table-action-icon-padding-y $table-action-icon-padding-x;
        margin-top: $table-action-icon-margin;
        margin-right: $table-action-icon-margin;
        border-radius: 2px;

        i { // Font icon
          @include font-size($font-size-md);
        }
      }
    }
  }

  thead th {
    position: sticky; // For fixed thead
    top: 0; // For fixed thead
    background-color: $table-head-bg;
    padding: $table-head-cell-padding-y $table-head-cell-padding-x;
    vertical-align: bottom;
    border-bottom: 0;
    text-transform: $table-head-text-transform;
    color: $table-head-color;
    font-weight: $font-weight-bold;
    box-shadow: 1px 0 $table-border-color, 0 1px $table-border-color;

  }

  tbody+tbody {
    border-top: (2 * $table-border-width) solid $table-border-color;
  }

}

thead.thead-bordered th:not(:last-child)::after {
  content: '';
  position: absolute;
  top: 0;
  right: 0;
  bottom: 0;
  margin: auto;
  width: 1px;
  height: calc(100% - 12px);
  background-color: $table-border-color;
}

//
// Table Vertical
//

.table-vertical {
  tbody td:first-child,
  tbody th:first-child {
    background-color: $table-accent-bg;
    border-right: $border-width solid $table-border-color;
    font-weight: $font-weight-bold;
  }
}


//
// Condensed table w/ half padding
//

.table-sm {

  th,
  td {
    padding: $table-cell-padding-sm !important;
  }
}


// Border versions
//
// Add or remove borders all around the table and between all the columns.

.table-bordered {
  border: $table-border-width solid $table-border-color;


  th,
  td {
    border: $table-border-width solid $table-border-color;
  }

  thead {

    th,
    td {
      border-bottom-width: 2 * $table-border-width;
    }
  }
}

.table-borderless {

  th,
  td,
  thead th,
  tbody+tbody {
    border: 0;
  }
}

// Zebra-striping
//
// Default zebra-stripe styles (alternating gray and transparent backgrounds)

.table-striped {
  tbody tr:nth-of-type(#{$table-striped-order}) {
    background-color: $table-accent-bg;
  }
}


// Hover effect
//
// Placed here since it has to come after the potential zebra striping

.table-hover {
  tbody tr {
    @include hover() {
      color: $table-hover-color;
      background-color: $table-hover-bg;
    }
  }
}

//
// Thead Variant
//

@each $color, $value in $theme-colors {
  .thead-#{$color} {
    th {
      color: $white !important;
      background-color: $value !important;
      box-shadow: 1px 0 darken($value, 7.5%), 0 1px darken($value, 7.5%) !important;

      &::after {
        background-color: darken($value, 7.5%) !important;
      }
    }
  }
}

// Dark styles
//
// Same table markup, but inverted color scheme: dark background and light text.

// stylelint-disable-next-line no-duplicate-selectors
.table {
  .thead-dark {
    th {
      color: $table-dark-color;
      background-color: $table-dark-bg;
      box-shadow: 1px 0 $table-dark-border-color, 0 1px $table-dark-border-color;
    }
  }

  .thead-light {
    th {
      color: $table-head-color;
      background-color: $table-light-bg;
      box-shadow: 1px 0 $table-border-color, 0 1px $table-border-color;
    }
  }
}

.table-dark {
  color: $table-dark-color;

  tbody td {
    background-color: $table-dark-bg;
    border-color: $table-dark-border-color;
  }

  thead th {
    color: $table-dark-color;
    background-color: $table-head-dark-bg;
    box-shadow: 1px 0 $table-head-dark-border-color, 0 1px $table-head-dark-border-color;

    &::after {
      background-color: $table-head-dark-border-color !important;
    }

  }

  &.table-bordered {
    border: 0;
  }

  &.table-striped {
    tbody tr:nth-of-type(#{$table-striped-order}) {
      background-color: $table-dark-accent-bg;
    }
  }

  &.table-hover {
    tbody tr {
      @include hover() {
        color: $table-dark-hover-color;
        background-color: $table-dark-hover-bg;
      }
    }
  }
}


// Responsive tables
//
// Generate series of `.table-responsive-*` classes for configuring the screen
// size of where your table will overflow.

.table-responsive {
  @each $breakpoint in map-keys($grid-breakpoints) {
    $next: breakpoint-next($breakpoint, $grid-breakpoints);
    $infix: breakpoint-infix($next, $grid-breakpoints);

    &#{$infix} {
      @include media-breakpoint-down($breakpoint) {
        display: block;
        width: 100%;
        overflow-x: auto;
        -webkit-overflow-scrolling: touch;

        // Prevent double border on horizontal scroll due to use of `display: block;`
        >.table-bordered {
          border: 0;
        }
      }
    }
  }

  @include media-breakpoint-down(sm) {
    tbody tr {
      white-space: no-wrap; // Prevent collapse text
    }
  }
}

@each $key in (even, odd) {
  .table-#{$key} {
    tbody tr td:nth-of-type(#{$key}) {
      background-color: $table-accent-bg;
    }
  }
}

.card-table {
  border-color: $table-border-color;
  .card-header {
    padding: 0;
    background-color: $table-head-bg;
    display: flex;
    align-items: center;
    border: none;

    .card-title {
      margin: 0;
      font-weight: $font-weight-medium;
      padding: 0 1rem;

      i {
        font-size: $font-size-lg;
      }
    }

    .table-action {
      display: flex;
      margin-left: auto;

      .btn {
        background-color: transparent;
        color: $gray-dark;
        padding: 6px 12px;
        font-weight: $font-weight-medium;
        border: none;

        &.refresh {
          @extend .btn-info;
          padding: 8px 10px;
        }
      }
    }
  }

  .card-body {
    padding: 0;

    table {
      border: none;
      margin: 0;
    }

    & *:first-child,
    & *:last-child {
      border-right: none;
      border-left: none;
    }

    table tfoot tr td {
      border-bottom: 0 !important;
      color: $table-color;
      text-align: center;
    }
  }

  .card-footer {
    display: flex;
    padding: 8px 4px;
    align-items: center;
    background-color: $white;

    .page-count {
      margin-left: 8px;
      order: 1;

      .label {
        font-weight: $font-weight-medium;
        @include font-size($font-size-md);
      }

      .value {
        @include font-size($font-size-sm);
      }
    }

    .page-rows {
      display: flex;
      align-items: center;
      order: 3;
      margin-right: 8px;

      @include media-breakpoint-down(sm) {
        display: none;
      }

      .label {
        font-weight: $font-weight-medium;
        font-size: $font-size-md;

        margin: {
          right: 4px;
          bottom: -1px;
        }

        ;
      }

      select {
        height: 25px;
        width: 50px;
        padding: 0;
      }
    }

    .pagination {
      margin: {
        left: auto;
        right: auto;
        bottom: 0;
      }

      ;
      font-size: $font-size-sm;
      order: 2;
    }
  }
}

// @media only screen and (max-width: 767px) {

//   .table-sm-vertical {
//     td, tr { display: block; }

//     thead tr {
//       position: absolute;
//       top: -99999px;
//       left: -99999px;
//     }
  
//     tr {
//       margin-bottom: .5rem;
//       border-bottom: $table-border-width solid $table-border-color;
//       background-color: transparent !important;
//     }
  
//     td {
//       padding: 0 !important;
//       border-right: $table-border-width solid $table-border-color;
//       border-left: none !important; // overide border by .table-bordered
//       border-bottom: none !important; // overide border by .table-bordered
//       width: auto !important;
//       text-align: left !important;
//     }
  
//     td::before {
//       content: attr(data-label);
//       display: inline-block;
//       background-color: $table-head-bg;
//       padding: $table-cell-padding-y $table-cell-padding-x;
//       margin-right: .75rem;
//       color: $table-head-color;
//       text-transform: $table-head-text-transform;
//       font-weight: $font-weight-medium;
//       border-right: $table-border-width solid $table-border-color;
//       border-left: $table-border-width solid $table-border-color;
//       width: 150px;
//     }
//   }
  
// }
